using System;
using System.IO;
using System.Text;
using System.Threading;
using System.Security.Cryptography;
using System.Runtime.InteropServices;



namespace Recchal
{
	/*
	 * IniFileクラスは他所から引用
	 * http://d.hatena.ne.jp/Rinta/20080712/p1
	 */
	/* INIファイル操作クラス */
	public class IniFile
	{
		public String GetIniFileString(String SecName,String KeyName,String FileName)
        {
            String line;
            String Value;
            bool SecFound;
            bool KeyFound;
            Value = "";
            SecName = "[" + SecName + "]";
            try
            {
                using (StreamReader sr = new StreamReader(FileName,System.Text.Encoding.GetEncoding("shift_jis")))
                {
                    SecFound = false;
                    line = "";
                    //セクション名による頭出し
                    while (!SecFound && ((line = sr.ReadLine()) != null))
                    {
                        line = line.Trim();
                        if ((line.Length >= SecName.Length) 
                        && (line.Substring(0, SecName.Length).Equals(SecName)))
                        {
                            SecFound = true;
                        }
                    }
                    KeyFound = false;
                    SecFound = false;
                    //セクション内のキーを探索。途中で他のセクションを発見したら終了。
                    while (!SecFound && !KeyFound && ((line = sr.ReadLine()) != null))
                    {
                        line = line.Trim();
                        if ((line.Length > 2) 
                        && (line.Substring(0, 1).Equals("["))
                        && (line.Substring(line.Length - 1, 1).Equals("]")))
                        {
                            SecFound = true;
                        }
                        else
                        {
                            if ((line.Length >= KeyName.Length)
                            && (line.Substring(0, KeyName.Length).Equals(KeyName)))
                            {
                                KeyFound = true;
                                Value = line.Substring(line.IndexOf("=") + 1
                                                      , line.Length - (line.IndexOf("=") + 1)
                                                      ).Trim();
                            }
                        }
                    }
                }
                return Value;
            }
            catch (Exception e)
            {
                return Value;
            }
        }
	}



	class Server
	{
		/* コンストラクタ */
		public Server()
		{
			Console.CancelKeyPress += new ConsoleCancelEventHandler(Ctrl_C_Pressed);
		}


		/* 終了時(Ctrl+C)に必ず実行 */
		public static void Ctrl_C_Pressed(object sender, ConsoleCancelEventArgs e)
		{
		}


		/* 現在時刻取得 */
		public static string nowTime()
		{
			DateTime nowTime = DateTime.Now;
			return nowTime.ToString("F");
		}


		/* ストリーミング停止 */
		//public static void Stream(string ChNum)
		public static void Stream(string CIP)
		{
			System.Diagnostics.Process recchalProc = new System.Diagnostics.Process();
			recchalProc.StartInfo.FileName	= "./script/stream-off.sh";
			recchalProc.StartInfo.Arguments	= CIP;
			recchalProc.Start();
		}


		/* ストリーミング変更 */
		public static void Stream(string ChNum, string CIP)
		{
			string argMsg = ChNum+" "+CIP;

			System.Diagnostics.Process recchalProc = new System.Diagnostics.Process();
			recchalProc.StartInfo.FileName	= "./script/stream-change.sh";
			recchalProc.StartInfo.Arguments	= argMsg;
			recchalProc.Start();
		}


		/* ストリーミング開始 */
		public static void Stream(string ChNum, string CIP, string CPort)
		{
			string argMsg = ChNum+" "+CIP+" "+CPort;

			System.Diagnostics.Process recchalProc = new System.Diagnostics.Process();
			recchalProc.StartInfo.FileName	= "./script/stream-on.sh";
			recchalProc.StartInfo.Arguments	= argMsg;
			recchalProc.Start();
		}



		//--
		/* recchal本体部 */


		/* クラス内グローバル変数 */
		public static System.Net.Sockets.TcpClient tcp;
		public static System.Net.Sockets.NetworkStream netStream;
		public static System.Text.Encoding enc;
		public static string hashServerPassword;


		public static void Main()
		{
			//グローバル
			string configFile = "./config.ini";
			string serverIpAdd	= null;
			string serverPassword = null;
			int serverPortNum;


			//INIファイル読み込み
			IniFile ini = new IniFile();
			serverIpAdd = ini.GetIniFileString("SystemConfig", "ServerIPAddress", configFile);
			serverPortNum = int.Parse(ini.GetIniFileString("SystemConfig", "ServerPortNumber", configFile));
			serverPassword = ini.GetIniFileString("SystemConfig", "ServerPassword", configFile); 


			//Passwordだけ暗号化(SHA1)
			byte[] byteServerPasswordValue = Encoding.UTF8.GetBytes(serverPassword);
            SHA1 crypt = new SHA1CryptoServiceProvider();
            byte[] hashServerPasswordValue = crypt.ComputeHash(byteServerPasswordValue);
            StringBuilder hashServerPasswordBuilder = new StringBuilder();
            for (int i = 0; i < hashServerPasswordValue.Length; i++){
                hashServerPasswordBuilder.AppendFormat("{0:X2}", hashServerPasswordValue[i]);
            }
            hashServerPassword = hashServerPasswordBuilder.ToString();


			//Binary->String(UTF8)の文字コード指定
			enc = System.Text.Encoding.UTF8;


			//ネットワークソケット
			System.Net.IPAddress localIpAdd = System.Net.Dns.GetHostEntry(serverIpAdd).AddressList[0];
			System.Net.Sockets.TcpListener listener = new System.Net.Sockets.TcpListener(localIpAdd, serverPortNum);
			listener.Start();


			//Main Server
			do{
				//接続要求の受け入れ
				tcp = listener.AcceptTcpClient();
				netStream = tcp.GetStream();

				Thread serverThread = new Thread(new ThreadStart(ServerThread));
				serverThread.Start();
			}while(true);


			//Closeing
				#pragma warning disable
			listener.Stop();
				#pragma warning restore
		}


		public static void ServerThread()
		{
			//ログカキコ
			using(System.IO.StreamWriter logFile = new System.IO.StreamWriter(@"./recchal_server.log",
																				true,
																				System.Text.Encoding.GetEncoding("UTF-8"))){
				//--
				logFile.WriteLine("_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/");
				logFile.Flush();
				//--


				//データ受信
				System.IO.MemoryStream memStream = new System.IO.MemoryStream();
				byte[] resBytes = new byte[256];  //とりあえず256あれば足りるべ
				int resSize;

				do{
					//データの一部を受信
					resSize = netStream.Read(resBytes, 0, resBytes.Length);

					if(resSize == 0){
						//--
						logFile.WriteLine("[{0}] : RecptDataFormatError", nowTime());
						logFile.Flush();
						//--
						return;
					}


					//受信データの蓄積
					memStream.Write(resBytes, 0, resSize);
				}while(netStream.DataAvailable);


				//受信データ(Binary)から文字列(String)に変換
				string recchalMsg = enc.GetString(memStream.ToArray());
				memStream.Close();


				//--
				logFile.WriteLine("[{0}] : ReceptionMessage", nowTime());
				logFile.Flush();
				logFile.WriteLine("    {0}", recchalMsg);
				logFile.Flush();
				//--


				/*受信データの各パラメータ分析
					FormMessage							:"[Opt],[ChNum],[CIP],[CPort]"
					0パラメータ	recchalCom[0]	[Pass]	:Server-Client connection password.
					1パラメータ	recchalCom[1]	[Opt]	:[stream-on], [stream-off], [change-channel
					2パラメータ	recchalCom[2]	[ChNum]	:PT2 ChannelNumber
					3パラメータ	recchalCom[3]	[CIP]	:recchal client IPaddress
					4パラメータ	recchalCom[4]	[CPort]	:recchal client PortNumber
				*/
				string[] recchalCom = recchalMsg.Split(',');


				//操作分岐
				if(hashServerPassword == recchalCom[0]){
					switch(recchalCom[1]){
						case "stream-off":
							Stream(recchalCom[3]);
							break;

						case "change-channel":
							Stream(recchalCom[2], recchalCom[3]);
							break;

						case "stream-on":
							Stream(recchalCom[2], recchalCom[3], recchalCom[4]);
							break;

						default:
							//--
							logFile.WriteLine("[{0}] : RecptMessageFormat Error", nowTime());
							logFile.Flush();
							//--
							break;
					}
				}else{
					//--
					logFile.WriteLine("[{0}] : ClientPassword no matching", nowTime());
					logFile.Flush();
					//--
				}


				//StreamClose
				netStream.Close();
				tcp.Close();
			}
		}
	}
}
